

#include "SDL.h"
#include "SDL_opengl.h"
#include "energy.h"
#include "util.h"
#include "config.h"

namespace PRJID {
	Energy::Energy(unsigned int m,unsigned int r) {
		max=m;
		regen=r;
		reset();
	}

	void Energy::reset() {
		current=max;
	}
	bool Energy::empty() {
		if (current>0) return false;
		return true;
	}
	bool Energy::tick(unsigned int ticks) {
		lastreduce.tick(ticks);
		return empty();
	}

	int Energy::percent() {
		float one=static_cast<float>(max)/100.0f;
		float perc=static_cast <float>(current)/one;

		int r=static_cast<int>(perc);
		if (r<0) r=0;
		if (r>100) r=100;
		return r;
	}
	void Energy::cap() {
		if (current>max) current=max;
	}

	void Energy::set_current(unsigned int c) {
		current=c;
		cap();
	}
	void Energy::gain(unsigned int g) {
		current+=g;
		cap();
	}
	void Energy::reduce(unsigned int g) {
		lastreduce=Timeleft(1000);
		if (g>=current) { 
			current=0;
		} else {
			current-=g;
		}
		cap();
	}
	void Energy::change(int g) {
		if (g>0) gain(g);
		if (g<0) reduce(g*-1);
		cap();
	}

	void Energy::dim(C3 c,C3f s,C3f t) {
		color=c;
		scale=s;
		trans=t;
	}

	void Energy::draw() {
		if (!lastreduce.over()) {
			glColor3ub(250,0,0);
			bar(
				C3(Config::cx()-200,Config::cy()-20),
				C3(150,40)
			);
			bar(
				C3(Config::cx()+50,Config::cy()-20),
				C3(150,40)
			);
		}
		if (percent()==0) return;
		glPushMatrix();
		glTranslatef(trans.x,trans.y,trans.z);
		glScalef(scale.x,scale.y,scale.z);
		glColor3ub(color.x,color.y,color.z);
		bar(
			C3(0,0),
			C3(percent(),1)
		);
		glPopMatrix();
	}


} //namespace
